﻿//********************************************************

//新增日期:  2008.9.19

//作    者:  Evan Chen 

//內容说明:　FlexStartMenu包装容器

//********************************************************
using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Drawing.Imaging;
using System.Windows.Forms;
using System.Reflection;

namespace MobileTest
{
    public delegate void PicItemInfo(FlexStartItem myControl);
    public class FlexStartMenu : System.Windows.Forms.Control
    {
        const int SCROLL_WIDTH = 10;
        int viewableItemCount;
        int rowsCount;
        int cellsCount;
        public event PicItemInfo Selected;
        string path = System.IO.Path.GetDirectoryName(Assembly.GetExecutingAssembly().GetName().CodeBase);

        public FlexStartMenu()
        {
            this.Items = new FlexStartItemCollections();

        }
        public FlexStartItemCollections Items
        {
            get;
            set;
        }
        //接受父窗体背景配色
        public Color SysColor
        {
            get;
            set;
        }
        //父窗体可见图标数
        public int ViewCount
        {
            get;
            set;
        }
        /// <summary>
        /// 被选中的项
        /// </summary>
        public FlexStartItem SelectedItem
        {
            get
            {
                FlexStartItem m_item = null;
                for (int i = 0; i < this.Items.Count; i++)
                {
                    if (Items[i].Press == true)
                    {
                        m_item = Items[i];
                        break;
                    }
                }
                return m_item;
            }
        }
        //定义一个Bitmap变量用双缓冲的方式防止闪烁
        protected Bitmap backBuffer;
        protected override void OnPaint(System.Windows.Forms.PaintEventArgs e)
        {
            if (backBuffer != null)
            {
                Graphics gOffScreen = Graphics.FromImage(backBuffer);
                gOffScreen.Clear(this.BackColor);
                this.BackColor=SysColor;
                viewableItemCount = ViewCount;
                string path = System.IO.Path.GetDirectoryName(Assembly.GetExecutingAssembly().GetName().CodeBase);

                AlphaImage bmp = AlphaImage.CreateFromFile(path + @"\Resources\background.png");
                Rectangle imgRect = new Rectangle(0,0, this.Width,this.Height);
                bmp.Draw(gOffScreen, imgRect);

                for (int i = 0; i < this.Items.Count; i++)
                {
                    DrawItem(this.Items[i], i, gOffScreen);
                }
                ////绘制九宫格边框
                //if (viewableItemCount == 9)
                //{
                //    //横向
                //    gOffScreen.DrawLine(new Pen(SystemColors.InactiveCaption), 0, 0, this.Width, 0);
                //    gOffScreen.DrawLine(new Pen(SystemColors.InactiveCaption), 0, this.Height / 3, this.Width, this.Height / 3);
                //    gOffScreen.DrawLine(new Pen(SystemColors.InactiveCaption), 0, this.Height * 2 / 3, this.Width, this.Height * 2 / 3);

                //    //纵向
                //    gOffScreen.DrawLine(new Pen(SystemColors.InactiveCaption), this.Width / 3, 0, this.Width / 3, this.Height);
                //    gOffScreen.DrawLine(new Pen(SystemColors.InactiveCaption), this.Width * 2 / 3, 0, this.Width * 2 / 3, this.Height);

                //}
                //else if (viewableItemCount == 8)
                //{
                //    //横向
                //    gOffScreen.DrawLine(new Pen(SystemColors.InactiveCaption), 0, 0, this.Width, 0);
                //    gOffScreen.DrawLine(new Pen(SystemColors.InactiveCaption), 0, this.Height / 2, this.Width, this.Height / 2);
                //    //纵向
                //    gOffScreen.DrawLine(new Pen(SystemColors.InactiveCaption), this.Width / 4, 0, this.Width / 4, this.Height);
                //    gOffScreen.DrawLine(new Pen(SystemColors.InactiveCaption), this.Width / 2, 0, this.Width / 2, this.Height);
                //    gOffScreen.DrawLine(new Pen(SystemColors.InactiveCaption), this.Width * 3 / 4, 0, this.Width * 3 / 4, this.Height);
                //}
                
                e.Graphics.DrawImage(backBuffer, 0, 0);
            }
            else
                e.Graphics.Clear(this.BackColor);
        }

        protected override void OnResize(EventArgs e)
        {
            base.OnResize(e);
            if (backBuffer != null)
                backBuffer.Dispose();

            backBuffer = new Bitmap(this.Width, this.Height);
        }
        private void DrawItem(FlexStartItem m_item, int index, Graphics gOffScreen)
        {
            m_item.Index = index + 1;
            if (viewableItemCount == 9)
            {
                rowsCount = 3;
                cellsCount = 3;
                TopAndLeft(m_item);
            }
            else if (viewableItemCount == 8)
            {
                rowsCount = 2;
                cellsCount = 4;
                TopAndLeftLands(m_item);
            }
            AlphaImage bmp = null;
            Font selFont;
            //选中时的图片
            if (m_item.Press && m_item.PressIcon != null)
            {
                bmp = m_item.PressIcon;
                selFont = new Font("宋体", 9, FontStyle.Bold);
            }
            else
            {
                bmp = m_item.Icon;
                selFont = new Font("宋体", 9, FontStyle.Regular);
            }

            //imgRect默认位置范围(绘制图片范围)
            Rectangle imgRect = new Rectangle((m_item.Left), (m_item.Top+this.Height / rowsCount * 2 / 5-30), this.Width/cellsCount, this.Height / rowsCount);

            //imgRect
            if (bmp != null)
            {
                bmp.Draw(gOffScreen, imgRect);
            }
            //绘制文字
            //gOffScreen.DrawString(m_item.ItemText, selFont, new SolidBrush(Color.White), (m_item.Left + 40 - gOffScreen.MeasureString(m_item.ItemText, selFont).Width / 2), (m_item.Top + this.Height / rowsCount * 2 / 5));
            
        }
        /// <summary>
        /// 捕获点击动作
        /// </summary>
        /// <param name="e"></param>
        protected override void OnMouseDown(MouseEventArgs e)
        {
            for (int i = 0; i < this.Items.Count; i++)
            {
                Rectangle itemRec = new Rectangle((this.Items[i].Left), (this.Items[i].Top + this.Height / rowsCount * 2 / 5 - 30), this.Width / cellsCount, this.Height / rowsCount);
                if (itemRec.Contains(e.X, e.Y))
                {
                    this.Items[i].Press = true;
                    Selected(this.Items[i]);
                    for (int j = 0; j < this.Items.Count; j++)
                    {
                        if (j != i)
                        {
                            this.Items[j].Press = false;
                        }
                    }
                    this.Invalidate();
                    break;
                }
            }
            base.OnMouseDown(e);
        }
        /// <summary>
        /// 计算N宫格的长宽高 可见范围:三列三行
        /// </summary>
        /// <param name="m_item"></param>
        private void TopAndLeft(FlexStartItem m_item)
        {
            int sumHeight=0;
            int itemCount=0;
            if(Items.Count % 3>=1)
            {
                itemCount = Convert.ToInt32(Math.Floor(Items.Count / 3 + 1));
                sumHeight = itemCount * (this.Height/3);
            }
            else if (Items.Count % 3 == 0)
            {
                itemCount = (Items.Count / 3 + 1);
                sumHeight = itemCount * (this.Height / 3);
            }

            int nowRow=0;
            if (m_item.Index % 3 >= 1)
            {
                nowRow = Convert.ToInt32(Math.Floor(m_item.Index / 3 + 1));
            }
            else if (m_item.Index % 3 == 0)
            {
                nowRow = m_item.Index / 3;
            }

            m_item.Top = sumHeight * (nowRow - 1) / itemCount;


            //第三列左边距
            if (m_item.Index % 3 == 0 && m_item.Index != 1)
            {
                m_item.Left = this.Width * 2 / 3;
            }
            //第二列左边据
            else if (m_item.Index == 2 || m_item.Index == 5 || m_item.Index == 8)
            {
                m_item.Left = this.Width / 3;
            }
            //第一列左边据
            else
                m_item.Left = 0;
        }

        /// <summary>
        /// 计算N宫格的长宽高 可见范围:四列两行
        /// </summary>
        /// <param name="m_item"></param>
        private void TopAndLeftLands(FlexStartItem m_item)
        {
            int sumHeight = 0;//总高
            int itemCount = 0;//行数
            if (Items.Count % 4 >= 1)
            {
                itemCount = Convert.ToInt32(Math.Floor(Items.Count / 4 + 1));
                sumHeight = itemCount * (this.Height / 2);//2为当前屏幕可以显示的行数
            }
            else if (Items.Count % 4 == 0)
            {
                itemCount = (Items.Count / 4);
                sumHeight = itemCount * (this.Height / 2);
            }

            int nowRow = 0;
            if (m_item.Index % 4 >= 1)
            {
                nowRow = Convert.ToInt32(Math.Floor(m_item.Index / 4 + 1));
            }
            else if (m_item.Index % 4 == 0)
            {
                nowRow = m_item.Index / 4;
            }

            m_item.Top = sumHeight * (nowRow - 1) / itemCount;


            //第四列左边距
            if (m_item.Index % 4 == 0 && m_item.Index != 1)
            {
                m_item.Left = this.Width * 3 / 4;
            }
            //第三列左边距
            else if (m_item.Index % 4 == 3 || m_item.Index == 3)
            {
                m_item.Left = this.Width / 2;
            }
            //第二列左边据
            else if (m_item.Index % 4 == 2 || m_item.Index == 2)
            {
                m_item.Left = this.Width / 4;
            }
            //第一列左边据
            else
                m_item.Left = 0;
        }

        protected override void OnPaintBackground(System.Windows.Forms.PaintEventArgs e)
        {
            //base.OnPaintBackground(e);
            //e.Graphics.DrawRectangle(new Pen(Color.Crimson), 0, 0, this.ClientSize.Width - 1, this.ClientSize.Height - 1);
        }
        /// <summary>
        /// 改变按键移动时选项的选中情况
        /// </summary>
        /// <param name="e"></param>
        protected override void OnKeyDown(System.Windows.Forms.KeyEventArgs e)
        {
            //除Live分类下其他分类按键
            if (SelectedItem != null)
            {
                int index = SelectedItem.Index - 1;
                switch (e.KeyCode)
                {
                    case Keys.Down:
                        //EnsureVisible(++this.SelectedItem.Index);
                        //三列三行
                        if (viewableItemCount == 9)
                        {
                            if (SelectedItem.Index > 6)
                            {
                                this.SelectedItem.Press = false;
                                this.Items[index - 6].Press = true;
                                this.Invalidate();
                            }
                            else
                            {
                                if ((index + 3) > Items.Count - 1)
                                {
                                    break;
                                }
                                this.SelectedItem.Press = false;
                                this.Items[index + 3].Press = true;
                                this.Invalidate();
                            }
                        }
                        //四列两行
                        else if (viewableItemCount == 8)
                        {
                            if (SelectedItem.Index > 4)
                            {
                                this.SelectedItem.Press = false;
                                this.Items[index - 4].Press = true;
                                this.Invalidate();
                            }
                            else
                            {
                                if ((index + 4) > Items.Count - 1)
                                {
                                    break;
                                }
                                this.SelectedItem.Press = false;
                                this.Items[index + 4].Press = true;
                                this.Invalidate();
                            }
                        }

                        break;
                    case Keys.Up:
                        //EnsureVisible(--this.SelectedItem.Index);
                        //三列三行
                        if (viewableItemCount == 9)
                        {
                            if (SelectedItem.Index <= 3)
                            {
                                if ((index + 6) > Items.Count - 1)
                                {
                                    break;
                                }
                                this.SelectedItem.Press = false;
                                this.Items[index + 6].Press = true;
                                this.Invalidate();
                            }
                            else
                            {
                                this.SelectedItem.Press = false;
                                this.Items[index - 3].Press = true;
                                this.Invalidate();
                            }
                        }
                        //四列两行
                        else if (viewableItemCount == 8)
                        {
                            if (SelectedItem.Index <= 4)
                            {
                                if ((index + 4) > Items.Count - 1)
                                {
                                    break;
                                }
                                this.SelectedItem.Press = false;
                                this.Items[index + 4].Press = true;
                                this.Invalidate();
                            }
                            else
                            {
                                this.SelectedItem.Press = false;
                                this.Items[index - 4].Press = true;
                                this.Invalidate();
                            }
                        }
                        break;
                    case Keys.Left:
                        if (SelectedItem.Index == 1)
                        {
                            this.SelectedItem.Press = false;
                            this.Items[Items.Count - 1].Press = true;
                            this.Invalidate();
                        }
                        else
                        {
                            this.SelectedItem.Press = false;
                            this.Items[index - 1].Press = true;
                            this.Invalidate();
                        }
                        break;
                    case Keys.Right:
                        if (SelectedItem.Index == Items.Count)
                        {
                            this.SelectedItem.Press = false;
                            this.Items[0].Press = true;
                            this.Invalidate();
                        }
                        else
                        {
                            this.SelectedItem.Press = false;
                            this.Items[index + 1].Press = true;
                            this.Invalidate();
                        }
                        break;
                    //ENTER事件
                    case Keys.Enter:
                        Selected(this.Items[index]);
                        break;
                }
            }
            //非正常选中事件处理
            else
            {
                this.Items[0].Press = true;
                this.Invalidate();
            }
            base.OnKeyDown(e);
        }
    }
}
